#include<TObject.h>
#include<TCanvas.h>
#include<TROOT.h>
#include<TFile.h>
#include<iostream>
#include<string>

using namespace std ;

TCanvas *NewC ;

inline TObject* GetFromFile( char* hname , char* fname, char* newname= 0 ) 
{  
  TFile* f = new TFile( fname ) ;
  if( f == 0 ) { cout << " file " << fname << " not found "<< endl ; return 0 ; }
  cout << "get histogram " << hname << " from file " << fname << endl;
  // f->ls() ;

  gROOT->cd();
  TObject* h ;

  h = dynamic_cast <TObject*> (f->Get( hname ))->Clone(newname) ;
  f->Close() ;
  if( h == 0 )
    { cout << " histogram " << hname << " does not exist "<< endl ;}
  else
    { cout << " histogram " << h->GetName() << " loaded with success " << endl ;}
  return h ;
}
inline void zone( Int_t nx=1 , Int_t ny=1, Int_t pos=1 , char* Name="NewC",char* opt
="nessuna" ) 
{
  NewC = new TCanvas( Name , Name, 600, 600 ) ;
  NewC->Divide( nx,ny,0.02,0,0 ) ;
  NewC->cd( pos ) ;
}
void DisplayPlots( char* kind="Tag" )
{

  const unsigned int nvar = 10 ;
  char* PlotName[nvar] = {"ZV","Pl","Ms","En","Q","Cos","Dm","NuM","Prb","LPrb"} ;

  int nplot ;
  if( strcmp( kind,"Tag" ) == 0 ) 
    { nplot = 8 ; }
  else if( strcmp( kind,"Dcy" ) == 0 ) 
    { nplot = 4 ; }
  else 
    {
      cout << " string " << kind << " is not allowed " << endl ;
      return ;
    }
  int nx(4) ;
  int ny = nplot/nx ;

  for( unsigned int i=0 ; i<nvar ; i++ ) 
    { 
      cout << kind << PlotName[i] << endl ; 
      zone(nx,ny); 
      for( int k=1 ; k<nplot+1 ; k++ ) 
	{
	  char hname[100] ;
	  int t = sprintf( hname,"%s%s_%d",kind,PlotName[i],k ) ;
	  TObject* h = GetFromFile( hname , "test.hist" ) ;
	  h->Draw() ;
	  NewC->cd(k+1) ;
	}
      char PlotName[100] ;
      int s = sprintf( PlotName,"%s.pdf",PlotName[i] ) ;
      NewC->Print( PlotName,"Landscape" ) ;
      NewC->Delete() ;
    }
}
