#define HSum_cxx
#include "HSum.h"
#include <TH1.h>
#include <TH1F.h>
#include <TDirectory.h>
#include <iostream>

using namespace std ;

HSum::HSum() {}
HSum::HSum( TH1F* h ) 
{
  _h = h ;
  _hint = (TH1F*) _h->Clone() ;
  _last = _h->GetNbinsX() ;
  _top = _h->GetMaximumBin() ;
} 
HSum::HSum( char* hname ) 
{  
  TH1F* h = (TH1F*) gDirectory->Get( hname ) ;
  _h = h ;
  _hint = (TH1F*) _h->Clone() ;
  _last = _h->GetNbinsX() ;
  _top = _h->GetMaximumBin() ;
}
/*int HSum::SumFirstToLast( char* hname ) 
{
  int step(1) ;
  int first(1) ;
  const unsigned int last = _h->GetNbinsX() ;
  double* sum = new double[last] ;
  sum = _h->GetIntegral() ;
  for( unsigned int i = first ; i < last ; i+=step )
    { 
      cout << i << " " << sum[i] << endl ;
      _hint->SetBinContent( i, sum[i] ) ;
    }
  for( unsigned int i = first ; i < last ; i+=step )
    { cout << i << " " << _hint->GetBinContent(i) << endl ; }
  if( hname != "" ) _hint->SetNameTitle( hname, hname ) ;
  cout << _hint->GetSum() << " " << _h->GetSum() <<  endl ;
  return 0 ;
  }*/

TH1F* HSum::SumFirstToLast( char* hname ) 
{
  GetIntegratedContent( 1, _last, 1 ) ;
  if( hname !="" ) _hint->SetNameTitle( hname, hname ) ;
  return _hint ;
 }
TH1F* HSum::SumLastToFirst( char* hname ) 
{ 
  GetIntegratedContent( _last, 1, -1 ) ;
  if( hname !="" ) _hint->SetNameTitle( hname, hname ) ;
  return _hint ;
}
TH1F* HSum::SumToMaximum( char* hname ) 
{ 
  GetIntegratedContent( _last, _top, -1 ) ; 
  GetIntegratedContent( 1, _top, 1 ) ; 
  if( hname !="" ) _hint->SetNameTitle( hname, hname ) ;
  return _hint ;
}  
void HSum::GetIntegratedContent(int imin, int imax, int step)
{
  cout << imin << " " << imax << " " << step << endl ;

  double val(0), sum(0) ;
  //  double sum = _h->GetSum() ;
  for(int i = imin ; i != imax+step ; i+=step )
    { sum += _h->GetBinContent(i); }

  for(int i = imin ; i != imax+step ; i+=step )
    { 
      val += _h->GetBinContent(i)/sum ;
      _hint->SetBinContent( i, val ) ;
      cout << i << " " << _hint->GetBinContent(i) << endl ;
    }
  cout << _hint->GetSum() << " " << _h->GetSum() <<  endl ;
}
