#ifndef mypart_h
#define mypart_h

#include "TLorentzVector.h"

class mypart {

 public :
  
  mypart() ;
  mypart( int charge, TLorentzVector FourVector, double ZV, double eZ );
  mypart( int charge, double px, double py, double pz, double mass, double ZV, double eZ );
  mypart( int charge, TLorentzVector FourVector, double ZV, double eZ, double x2 );
  mypart( const mypart& apart ) ;
  
  TLorentzVector GetFourVector() ;
  int    GetCharge() ;
  int    GetMultiplicity() ;
  double GetVertexPosition() ;
  double GetVertexError() ;
  double GetChiSquare() ;


  mypart& operator = ( const mypart & P ) ;
  mypart& operator + ( const mypart & P ) ;
  mypart& operator += ( const mypart & P ) ;
  
  
  ~mypart() ;

 private :

  int _ch, _n ;
  TLorentzVector _fv ;
  double _zv, _ez, _x2 ;
  void copy( const mypart& P ) ;
  void ComputeCommonVertex( const mypart & P ) ;
};
#endif 
  
  
